Commit cb3086ce authored by David S. Miller's avatar David S. Miller

Merge branch 'bridge-mdb-limit'

Petr Machata says:

====================
bridge: Limit number of MDB entries per port, port-vlan

The MDB maintained by the bridge is limited. When the bridge is configured
for IGMP / MLD snooping, a buggy or malicious client can easily exhaust its
capacity. In SW datapath, the capacity is configurable through the
IFLA_BR_MCAST_HASH_MAX parameter, but ultimately is finite. Obviously a
similar limit exists in the HW datapath for purposes of offloading.

In order to prevent the issue of unilateral exhaustion of MDB resources,
introduce two parameters in each of two contexts:

- Per-port and (when BROPT_MCAST_VLAN_SNOOPING_ENABLED is enabled)
  per-port-VLAN number of MDB entries that the port is member in.

- Per-port and (when BROPT_MCAST_VLAN_SNOOPING_ENABLED is enabled)
  per-port-VLAN maximum permitted number of MDB entries, or 0 for
  no limit.

Per-port number of entries keeps track of the total number of MDB entries
configured on a given port. The per-port-VLAN value then keeps track of the
subset of MDB entries configured specifically for the given VLAN, on that
port. The number is adjusted as port_groups are created and deleted, and
therefore under multicast lock.

A maximum value, if non-zero, then places a limit on the number of entries
that can be configured in a given context. Attempts to add entries above
the maximum are rejected.

Rejection reason of netlink-based requests to add MDB entries is
communicated through extack. This channel is unavailable for rejections
triggered from the control path. To address this lack of visibility, the
patchset adds a tracepoint, bridge:br_mdb_full:

	# perf record -e bridge:br_mdb_full &
	# [...]
	# perf script | cut -d: -f4-
	 dev v2 af 2 src ::ffff:0.0.0.0 grp ::ffff:239.1.1.112/00:00:00:00:00:00 vid 0
	 dev v2 af 10 src :: grp ff0e::112/00:00:00:00:00:00 vid 0
	 dev v2 af 2 src ::ffff:0.0.0.0 grp ::ffff:239.1.1.112/00:00:00:00:00:00 vid 10
	 dev v2 af 10 src 2001:db8:1::1 grp ff0e::1/00:00:00:00:00:00 vid 10
	 dev v2 af 2 src ::ffff:192.0.2.1 grp ::ffff:239.1.1.1/00:00:00:00:00:00 vid 10

Another option to consume the tracepoint is e.g. through the bpftrace tool:

	# bpftrace -e ' tracepoint:bridge:br_mdb_full /args->af != 0/ {
			    printf("dev %s src %s grp %s vid %u\n",
				   str(args->dev), ntop(args->src),
				   ntop(args->grp), args->vid);
			}
			tracepoint:bridge:br_mdb_full /args->af == 0/ {
			    printf("dev %s grp %s vid %u\n",
				   str(args->dev),
				   macaddr(args->grpmac), args->vid);
			}'

This tracepoint is triggered for mcast_hash_max exhaustions as well.

The following is an example of how the feature is used. A more extensive
example is available in patch #8:

	# bridge vlan set dev v1 vid 1 mcast_max_groups 1
	# bridge mdb add dev br port v1 grp 230.1.2.3 temp vid 1
	# bridge mdb add dev br port v1 grp 230.1.2.4 temp vid 1
	Error: bridge: Port-VLAN is already in 1 groups, and mcast_max_groups=1.

The patchset progresses as follows:

- In patch #1, set strict_start_type at two bridge-related policies. The
  reason is we are adding a new attribute to one of these, and want the new
  attribute to be parsed strictly. The other was adjusted for completeness'
  sake.

- In patches #2 to #5, br_mdb and br_multicast code is adjusted to make the
  following additions smoother.

- In patch #6, add the tracepoint.

- In patch #7, the code to maintain number of MDB entries is added as
  struct net_bridge_mcast_port::mdb_n_entries. The maximum is added, too,
  as struct net_bridge_mcast_port::mdb_max_entries, however at this point
  there is no way to set the value yet, and since 0 is treated as "no
  limit", the functionality doesn't change at this point. Note however,
  that mcast_hash_max violations already do trigger at this point.

- In patch #8, netlink plumbing is added: reading of number of entries, and
  reading and writing of maximum.

  The per-port values are passed through RTM_NEWLINK / RTM_GETLINK messages
  in IFLA_BRPORT_MCAST_N_GROUPS and _MAX_GROUPS, inside IFLA_PROTINFO nest.

  The per-port-vlan values are passed through RTM_GETVLAN / RTM_NEWVLAN
  messages in BRIDGE_VLANDB_ENTRY_MCAST_N_GROUPS, _MAX_GROUPS, inside
  BRIDGE_VLANDB_ENTRY.

The following patches deal with the selftest:

- Patches #9 and #10 clean up and move around some selftest code.

- Patches #11 to #14 add helpers and generalize the existing IGMP / MLD
  support to allow generating packets with configurable group addresses and
  varying source lists for (S,G) memberships.

- Patch #15 adds code to generate IGMP leave and MLD done packets.

- Patch #16 finally adds the selftest itself.

v3:
- Patch #7:
    - Access mdb_max_/_n_entries through READ_/WRITE_ONCE
    - Move extack setting to br_multicast_port_ngroups_inc_one().
      Since we use NL_SET_ERR_MSG_FMT_MOD, the correct context
      (port / port-vlan) can be passed through an argument.
      This also removes the need for more READ/WRITE_ONCE's
      at the extack-setting site.
- Patch #8:
    - Move the br_multicast_port_ctx_vlan_disabled() check
      out to the _vlan_ helpers callers. Thus these helpers
      cannot fail, which makes them very similar to the
      _port_ helpers. Have them take the MC context directly
      and unify them.

v2:
- Cover letter:
    - Add an example of a bpftrace-based probe script
- Patch #6:
    - Report IPv4 as an IPv6-mapped address through the IPv6 buffer
      as well, to save ring buffer space.
- Patch #7:
    - In br_multicast_port_ngroups_inc_one(), bounce
      if n>=max, not if n==max
    - Adjust extack messages to mention ngroups, now
      that the bounces appear when n>=max, not n==max
    - In __br_multicast_enable_port_ctx(), do not reset
      max to 0. Also do not count number of entries by
      going through _inc, as that would end up incorrectly
      bouncing the entries.
- Patch #8:
    - Drop locks around accesses in
      br_multicast_{port,vlan}_ngroups_{get,set_max}(),
    - Drop bounces due to max<n in
      br_multicast_{port,vlan}_ngroups_set_max().
- Patch #12:
    - In the comment at payload_template_calc_checksum(),
      s/%#02x/%02x/, that's the mausezahn payload format.
- Patch #16:
    - Adjust the tests that check setting max below n and
      reset of max on VLAN snooping enablement
    - Make test naming uniform
    - Enable testing of control path (IGMP/MLD) in
      mcast_vlan_snooping bridge
    - Reorganize the code so that test instances (per bridge
      type and configuration type) always come right after
      the test, in order of {d,q,qvs}{4,6}{cfg,ctl}.
      Then groups of selftests are at the end of the file.
      Similarly adjust invocation order of the tests.
====================
Signed-off-by: default avatarDavid S. Miller <davem@davemloft.net>
parents 8b7018fa 3446dcd7
......@@ -122,6 +122,64 @@ TRACE_EVENT(br_fdb_update,
__entry->flags)
);
TRACE_EVENT(br_mdb_full,
TP_PROTO(const struct net_device *dev,
const struct br_ip *group),
TP_ARGS(dev, group),
TP_STRUCT__entry(
__string(dev, dev->name)
__field(int, af)
__field(u16, vid)
__array(__u8, src, 16)
__array(__u8, grp, 16)
__array(__u8, grpmac, ETH_ALEN) /* For af == 0. */
),
TP_fast_assign(
struct in6_addr *in6;
__assign_str(dev, dev->name);
__entry->vid = group->vid;
if (!group->proto) {
__entry->af = 0;
memset(__entry->src, 0, sizeof(__entry->src));
memset(__entry->grp, 0, sizeof(__entry->grp));
memcpy(__entry->grpmac, group->dst.mac_addr, ETH_ALEN);
} else if (group->proto == htons(ETH_P_IP)) {
__entry->af = AF_INET;
in6 = (struct in6_addr *)__entry->src;
ipv6_addr_set_v4mapped(group->src.ip4, in6);
in6 = (struct in6_addr *)__entry->grp;
ipv6_addr_set_v4mapped(group->dst.ip4, in6);
memset(__entry->grpmac, 0, ETH_ALEN);
#if IS_ENABLED(CONFIG_IPV6)
} else {
__entry->af = AF_INET6;
in6 = (struct in6_addr *)__entry->src;
*in6 = group->src.ip6;
in6 = (struct in6_addr *)__entry->grp;
*in6 = group->dst.ip6;
memset(__entry->grpmac, 0, ETH_ALEN);
#endif
}
),
TP_printk("dev %s af %u src %pI6c grp %pI6c/%pM vid %u",
__get_str(dev), __entry->af, __entry->src, __entry->grp,
__entry->grpmac, __entry->vid)
);
#endif /* _TRACE_BRIDGE_H */
......
......@@ -523,6 +523,8 @@ enum {
BRIDGE_VLANDB_ENTRY_TUNNEL_INFO,
BRIDGE_VLANDB_ENTRY_STATS,
BRIDGE_VLANDB_ENTRY_MCAST_ROUTER,
BRIDGE_VLANDB_ENTRY_MCAST_N_GROUPS,
BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS,
__BRIDGE_VLANDB_ENTRY_MAX,
};
#define BRIDGE_VLANDB_ENTRY_MAX (__BRIDGE_VLANDB_ENTRY_MAX - 1)
......
......@@ -567,6 +567,8 @@ enum {
IFLA_BRPORT_MCAST_EHT_HOSTS_CNT,
IFLA_BRPORT_LOCKED,
IFLA_BRPORT_MAB,
IFLA_BRPORT_MCAST_N_GROUPS,
IFLA_BRPORT_MCAST_MAX_GROUPS,
__IFLA_BRPORT_MAX
};
#define IFLA_BRPORT_MAX (__IFLA_BRPORT_MAX - 1)
......
......@@ -849,11 +849,10 @@ static int br_mdb_add_group_sg(const struct br_mdb_config *cfg,
}
p = br_multicast_new_port_group(cfg->p, &cfg->group, *pp, flags, NULL,
MCAST_INCLUDE, cfg->rt_protocol);
if (unlikely(!p)) {
NL_SET_ERR_MSG_MOD(extack, "Couldn't allocate new (S, G) port group");
MCAST_INCLUDE, cfg->rt_protocol, extack);
if (unlikely(!p))
return -ENOMEM;
}
rcu_assign_pointer(*pp, p);
if (!(flags & MDB_PG_FLAGS_PERMANENT) && !cfg->src_entry)
mod_timer(&p->timer,
......@@ -1075,11 +1074,10 @@ static int br_mdb_add_group_star_g(const struct br_mdb_config *cfg,
}
p = br_multicast_new_port_group(cfg->p, &cfg->group, *pp, flags, NULL,
cfg->filter_mode, cfg->rt_protocol);
if (unlikely(!p)) {
NL_SET_ERR_MSG_MOD(extack, "Couldn't allocate new (*, G) port group");
cfg->filter_mode, cfg->rt_protocol,
extack);
if (unlikely(!p))
return -ENOMEM;
}
err = br_mdb_add_group_srcs(cfg, p, brmctx, extack);
if (err)
......@@ -1101,8 +1099,7 @@ static int br_mdb_add_group_star_g(const struct br_mdb_config *cfg,
return 0;
err_del_port_group:
hlist_del_init(&p->mglist);
kfree(p);
br_multicast_del_port_group(p);
return err;
}
......
......@@ -31,6 +31,7 @@
#include <net/ip6_checksum.h>
#include <net/addrconf.h>
#endif
#include <trace/events/bridge.h>
#include "br_private.h"
#include "br_private_mcast_eht.h"
......@@ -234,6 +235,29 @@ br_multicast_pg_to_port_ctx(const struct net_bridge_port_group *pg)
return pmctx;
}
static struct net_bridge_mcast_port *
br_multicast_port_vid_to_port_ctx(struct net_bridge_port *port, u16 vid)
{
struct net_bridge_mcast_port *pmctx = NULL;
struct net_bridge_vlan *vlan;
lockdep_assert_held_once(&port->br->multicast_lock);
if (!br_opt_get(port->br, BROPT_MCAST_VLAN_SNOOPING_ENABLED))
return NULL;
/* Take RCU to access the vlan. */
rcu_read_lock();
vlan = br_vlan_find(nbp_vlan_group_rcu(port), vid);
if (vlan && !br_multicast_port_ctx_vlan_disabled(&vlan->port_mcast_ctx))
pmctx = &vlan->port_mcast_ctx;
rcu_read_unlock();
return pmctx;
}
/* when snooping we need to check if the contexts should be used
* in the following order:
* - if pmctx is non-NULL (port), check if it should be used
......@@ -668,6 +692,101 @@ void br_multicast_del_group_src(struct net_bridge_group_src *src,
__br_multicast_del_group_src(src);
}
static int
br_multicast_port_ngroups_inc_one(struct net_bridge_mcast_port *pmctx,
struct netlink_ext_ack *extack,
const char *what)
{
u32 max = READ_ONCE(pmctx->mdb_max_entries);
u32 n = READ_ONCE(pmctx->mdb_n_entries);
if (max && n >= max) {
NL_SET_ERR_MSG_FMT_MOD(extack, "%s is already in %u groups, and mcast_max_groups=%u",
what, n, max);
return -E2BIG;
}
WRITE_ONCE(pmctx->mdb_n_entries, n + 1);
return 0;
}
static void br_multicast_port_ngroups_dec_one(struct net_bridge_mcast_port *pmctx)
{
u32 n = READ_ONCE(pmctx->mdb_n_entries);
WARN_ON_ONCE(n == 0);
WRITE_ONCE(pmctx->mdb_n_entries, n - 1);
}
static int br_multicast_port_ngroups_inc(struct net_bridge_port *port,
const struct br_ip *group,
struct netlink_ext_ack *extack)
{
struct net_bridge_mcast_port *pmctx;
int err;
lockdep_assert_held_once(&port->br->multicast_lock);
/* Always count on the port context. */
err = br_multicast_port_ngroups_inc_one(&port->multicast_ctx, extack,
"Port");
if (err) {
trace_br_mdb_full(port->dev, group);
return err;
}
/* Only count on the VLAN context if VID is given, and if snooping on
* that VLAN is enabled.
*/
if (!group->vid)
return 0;
pmctx = br_multicast_port_vid_to_port_ctx(port, group->vid);
if (!pmctx)
return 0;
err = br_multicast_port_ngroups_inc_one(pmctx, extack, "Port-VLAN");
if (err) {
trace_br_mdb_full(port->dev, group);
goto dec_one_out;
}
return 0;
dec_one_out:
br_multicast_port_ngroups_dec_one(&port->multicast_ctx);
return err;
}
static void br_multicast_port_ngroups_dec(struct net_bridge_port *port, u16 vid)
{
struct net_bridge_mcast_port *pmctx;
lockdep_assert_held_once(&port->br->multicast_lock);
if (vid) {
pmctx = br_multicast_port_vid_to_port_ctx(port, vid);
if (pmctx)
br_multicast_port_ngroups_dec_one(pmctx);
}
br_multicast_port_ngroups_dec_one(&port->multicast_ctx);
}
u32 br_multicast_ngroups_get(const struct net_bridge_mcast_port *pmctx)
{
return READ_ONCE(pmctx->mdb_n_entries);
}
void br_multicast_ngroups_set_max(struct net_bridge_mcast_port *pmctx, u32 max)
{
WRITE_ONCE(pmctx->mdb_max_entries, max);
}
u32 br_multicast_ngroups_get_max(const struct net_bridge_mcast_port *pmctx)
{
return READ_ONCE(pmctx->mdb_max_entries);
}
static void br_multicast_destroy_port_group(struct net_bridge_mcast_gc *gc)
{
struct net_bridge_port_group *pg;
......@@ -702,6 +821,7 @@ void br_multicast_del_pg(struct net_bridge_mdb_entry *mp,
} else {
br_multicast_star_g_handle_mode(pg, MCAST_INCLUDE);
}
br_multicast_port_ngroups_dec(pg->key.port, pg->key.addr.vid);
hlist_add_head(&pg->mcast_gc.gc_node, &br->mcast_gc_list);
queue_work(system_long_wq, &br->mcast_gc_work);
......@@ -1165,6 +1285,7 @@ struct net_bridge_mdb_entry *br_multicast_new_group(struct net_bridge *br,
return mp;
if (atomic_read(&br->mdb_hash_tbl.nelems) >= br->hash_max) {
trace_br_mdb_full(br->dev, group);
br_mc_disabled_update(br->dev, false, NULL);
br_opt_toggle(br, BROPT_MULTICAST_ENABLED, false);
return ERR_PTR(-E2BIG);
......@@ -1284,14 +1405,22 @@ struct net_bridge_port_group *br_multicast_new_port_group(
unsigned char flags,
const unsigned char *src,
u8 filter_mode,
u8 rt_protocol)
u8 rt_protocol,
struct netlink_ext_ack *extack)
{
struct net_bridge_port_group *p;
int err;
p = kzalloc(sizeof(*p), GFP_ATOMIC);
if (unlikely(!p))
err = br_multicast_port_ngroups_inc(port, group, extack);
if (err)
return NULL;
p = kzalloc(sizeof(*p), GFP_ATOMIC);
if (unlikely(!p)) {
NL_SET_ERR_MSG_MOD(extack, "Couldn't allocate new port group");
goto dec_out;
}
p->key.addr = *group;
p->key.port = port;
p->flags = flags;
......@@ -1305,8 +1434,8 @@ struct net_bridge_port_group *br_multicast_new_port_group(
if (!br_multicast_is_star_g(group) &&
rhashtable_lookup_insert_fast(&port->br->sg_port_tbl, &p->rhnode,
br_sg_port_rht_params)) {
kfree(p);
return NULL;
NL_SET_ERR_MSG_MOD(extack, "Couldn't insert new port group");
goto free_out;
}
rcu_assign_pointer(p->next, next);
......@@ -1320,6 +1449,25 @@ struct net_bridge_port_group *br_multicast_new_port_group(
eth_broadcast_addr(p->eth_addr);
return p;
free_out:
kfree(p);
dec_out:
br_multicast_port_ngroups_dec(port, group->vid);
return NULL;
}
void br_multicast_del_port_group(struct net_bridge_port_group *p)
{
struct net_bridge_port *port = p->key.port;
__u16 vid = p->key.addr.vid;
hlist_del_init(&p->mglist);
if (!br_multicast_is_star_g(&p->key.addr))
rhashtable_remove_fast(&port->br->sg_port_tbl, &p->rhnode,
br_sg_port_rht_params);
kfree(p);
br_multicast_port_ngroups_dec(port, vid);
}
void br_multicast_host_join(const struct net_bridge_mcast *brmctx,
......@@ -1387,7 +1535,7 @@ __br_multicast_add_group(struct net_bridge_mcast *brmctx,
}
p = br_multicast_new_port_group(pmctx->port, group, *pp, 0, src,
filter_mode, RTPROT_KERNEL);
filter_mode, RTPROT_KERNEL, NULL);
if (unlikely(!p)) {
p = ERR_PTR(-ENOMEM);
goto out;
......@@ -1933,6 +2081,25 @@ static void __br_multicast_enable_port_ctx(struct net_bridge_mcast_port *pmctx)
br_ip4_multicast_add_router(brmctx, pmctx);
br_ip6_multicast_add_router(brmctx, pmctx);
}
if (br_multicast_port_ctx_is_vlan(pmctx)) {
struct net_bridge_port_group *pg;
u32 n = 0;
/* The mcast_n_groups counter might be wrong. First,
* BR_VLFLAG_MCAST_ENABLED is toggled before temporary entries
* are flushed, thus mcast_n_groups after the toggle does not
* reflect the true values. And second, permanent entries added
* while BR_VLFLAG_MCAST_ENABLED was disabled, are not reflected
* either. Thus we have to refresh the counter.
*/
hlist_for_each_entry(pg, &pmctx->port->mglist, mglist) {
if (pg->key.addr.vid == pmctx->vlan->vid)
n++;
}
WRITE_ONCE(pmctx->mdb_n_entries, n);
}
}
void br_multicast_enable_port(struct net_bridge_port *port)
......
......@@ -202,6 +202,8 @@ static inline size_t br_port_info_size(void)
+ nla_total_size_64bit(sizeof(u64)) /* IFLA_BRPORT_HOLD_TIMER */
#ifdef CONFIG_BRIDGE_IGMP_SNOOPING
+ nla_total_size(sizeof(u8)) /* IFLA_BRPORT_MULTICAST_ROUTER */
+ nla_total_size(sizeof(u32)) /* IFLA_BRPORT_MCAST_N_GROUPS */
+ nla_total_size(sizeof(u32)) /* IFLA_BRPORT_MCAST_MAX_GROUPS */
#endif
+ nla_total_size(sizeof(u16)) /* IFLA_BRPORT_GROUP_FWD_MASK */
+ nla_total_size(sizeof(u8)) /* IFLA_BRPORT_MRP_RING_OPEN */
......@@ -298,7 +300,11 @@ static int br_port_fill_attrs(struct sk_buff *skb,
nla_put_u32(skb, IFLA_BRPORT_MCAST_EHT_HOSTS_LIMIT,
p->multicast_eht_hosts_limit) ||
nla_put_u32(skb, IFLA_BRPORT_MCAST_EHT_HOSTS_CNT,
p->multicast_eht_hosts_cnt))
p->multicast_eht_hosts_cnt) ||
nla_put_u32(skb, IFLA_BRPORT_MCAST_N_GROUPS,
br_multicast_ngroups_get(&p->multicast_ctx)) ||
nla_put_u32(skb, IFLA_BRPORT_MCAST_MAX_GROUPS,
br_multicast_ngroups_get_max(&p->multicast_ctx)))
return -EMSGSIZE;
#endif
......@@ -858,6 +864,8 @@ static int br_afspec(struct net_bridge *br,
}
static const struct nla_policy br_port_policy[IFLA_BRPORT_MAX + 1] = {
[IFLA_BRPORT_UNSPEC] = { .strict_start_type =
IFLA_BRPORT_MCAST_EHT_HOSTS_LIMIT + 1 },
[IFLA_BRPORT_STATE] = { .type = NLA_U8 },
[IFLA_BRPORT_COST] = { .type = NLA_U32 },
[IFLA_BRPORT_PRIORITY] = { .type = NLA_U16 },
......@@ -881,6 +889,8 @@ static const struct nla_policy br_port_policy[IFLA_BRPORT_MAX + 1] = {
[IFLA_BRPORT_MAB] = { .type = NLA_U8 },
[IFLA_BRPORT_BACKUP_PORT] = { .type = NLA_U32 },
[IFLA_BRPORT_MCAST_EHT_HOSTS_LIMIT] = { .type = NLA_U32 },
[IFLA_BRPORT_MCAST_N_GROUPS] = { .type = NLA_REJECT },
[IFLA_BRPORT_MCAST_MAX_GROUPS] = { .type = NLA_U32 },
};
/* Change the state of the port and notify spanning tree */
......@@ -1015,6 +1025,13 @@ static int br_setport(struct net_bridge_port *p, struct nlattr *tb[],
if (err)
return err;
}
if (tb[IFLA_BRPORT_MCAST_MAX_GROUPS]) {
u32 max_groups;
max_groups = nla_get_u32(tb[IFLA_BRPORT_MCAST_MAX_GROUPS]);
br_multicast_ngroups_set_max(&p->multicast_ctx, max_groups);
}
#endif
if (tb[IFLA_BRPORT_GROUP_FWD_MASK]) {
......
......@@ -188,6 +188,9 @@ int br_fill_vlan_tunnel_info(struct sk_buff *skb,
}
static const struct nla_policy vlan_tunnel_policy[IFLA_BRIDGE_VLAN_TUNNEL_MAX + 1] = {
[IFLA_BRIDGE_VLAN_TUNNEL_UNSPEC] = {
.strict_start_type = IFLA_BRIDGE_VLAN_TUNNEL_FLAGS + 1
},
[IFLA_BRIDGE_VLAN_TUNNEL_ID] = { .type = NLA_U32 },
[IFLA_BRIDGE_VLAN_TUNNEL_VID] = { .type = NLA_U16 },
[IFLA_BRIDGE_VLAN_TUNNEL_FLAGS] = { .type = NLA_U16 },
......
......@@ -126,6 +126,8 @@ struct net_bridge_mcast_port {
struct hlist_node ip6_rlist;
#endif /* IS_ENABLED(CONFIG_IPV6) */
unsigned char multicast_router;
u32 mdb_n_entries;
u32 mdb_max_entries;
#endif /* CONFIG_BRIDGE_IGMP_SNOOPING */
};
......@@ -956,7 +958,9 @@ br_multicast_new_port_group(struct net_bridge_port *port,
const struct br_ip *group,
struct net_bridge_port_group __rcu *next,
unsigned char flags, const unsigned char *src,
u8 filter_mode, u8 rt_protocol);
u8 filter_mode, u8 rt_protocol,
struct netlink_ext_ack *extack);
void br_multicast_del_port_group(struct net_bridge_port_group *p);
int br_mdb_hash_init(struct net_bridge *br);
void br_mdb_hash_fini(struct net_bridge *br);
void br_mdb_notify(struct net_device *dev, struct net_bridge_mdb_entry *mp,
......@@ -974,6 +978,9 @@ void br_multicast_uninit_stats(struct net_bridge *br);
void br_multicast_get_stats(const struct net_bridge *br,
const struct net_bridge_port *p,
struct br_mcast_stats *dest);
u32 br_multicast_ngroups_get(const struct net_bridge_mcast_port *pmctx);
void br_multicast_ngroups_set_max(struct net_bridge_mcast_port *pmctx, u32 max);
u32 br_multicast_ngroups_get_max(const struct net_bridge_mcast_port *pmctx);
void br_mdb_init(void);
void br_mdb_uninit(void);
void br_multicast_host_join(const struct net_bridge_mcast *brmctx,
......@@ -1757,7 +1764,8 @@ static inline u16 br_vlan_flags(const struct net_bridge_vlan *v, u16 pvid)
#ifdef CONFIG_BRIDGE_VLAN_FILTERING
bool br_vlan_opts_eq_range(const struct net_bridge_vlan *v_curr,
const struct net_bridge_vlan *range_end);
bool br_vlan_opts_fill(struct sk_buff *skb, const struct net_bridge_vlan *v);
bool br_vlan_opts_fill(struct sk_buff *skb, const struct net_bridge_vlan *v,
const struct net_bridge_port *p);
size_t br_vlan_opts_nl_size(void);
int br_vlan_process_options(const struct net_bridge *br,
const struct net_bridge_port *p,
......
......@@ -1816,6 +1816,7 @@ static bool br_vlan_stats_fill(struct sk_buff *skb,
/* v_opts is used to dump the options which must be equal in the whole range */
static bool br_vlan_fill_vids(struct sk_buff *skb, u16 vid, u16 vid_range,
const struct net_bridge_vlan *v_opts,
const struct net_bridge_port *p,
u16 flags,
bool dump_stats)
{
......@@ -1842,7 +1843,7 @@ static bool br_vlan_fill_vids(struct sk_buff *skb, u16 vid, u16 vid_range,
goto out_err;
if (v_opts) {
if (!br_vlan_opts_fill(skb, v_opts))
if (!br_vlan_opts_fill(skb, v_opts, p))
goto out_err;
if (dump_stats && !br_vlan_stats_fill(skb, v_opts))
......@@ -1925,7 +1926,7 @@ void br_vlan_notify(const struct net_bridge *br,
goto out_kfree;
}
if (!br_vlan_fill_vids(skb, vid, vid_range, v, flags, false))
if (!br_vlan_fill_vids(skb, vid, vid_range, v, p, flags, false))
goto out_err;
nlmsg_end(skb, nlh);
......@@ -2030,7 +2031,7 @@ static int br_vlan_dump_dev(const struct net_device *dev,
if (!br_vlan_fill_vids(skb, range_start->vid,
range_end->vid, range_start,
vlan_flags, dump_stats)) {
p, vlan_flags, dump_stats)) {
err = -EMSGSIZE;
break;
}
......@@ -2056,7 +2057,7 @@ static int br_vlan_dump_dev(const struct net_device *dev,
else if (!dump_global &&
!br_vlan_fill_vids(skb, range_start->vid,
range_end->vid, range_start,
br_vlan_flags(range_start, pvid),
p, br_vlan_flags(range_start, pvid),
dump_stats))
err = -EMSGSIZE;
}
......@@ -2131,6 +2132,8 @@ static const struct nla_policy br_vlan_db_policy[BRIDGE_VLANDB_ENTRY_MAX + 1] =
[BRIDGE_VLANDB_ENTRY_STATE] = { .type = NLA_U8 },
[BRIDGE_VLANDB_ENTRY_TUNNEL_INFO] = { .type = NLA_NESTED },
[BRIDGE_VLANDB_ENTRY_MCAST_ROUTER] = { .type = NLA_U8 },
[BRIDGE_VLANDB_ENTRY_MCAST_N_GROUPS] = { .type = NLA_REJECT },
[BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS] = { .type = NLA_U32 },
};
static int br_vlan_rtm_process_one(struct net_device *dev,
......
......@@ -48,7 +48,8 @@ bool br_vlan_opts_eq_range(const struct net_bridge_vlan *v_curr,
curr_mc_rtr == range_mc_rtr;
}
bool br_vlan_opts_fill(struct sk_buff *skb, const struct net_bridge_vlan *v)
bool br_vlan_opts_fill(struct sk_buff *skb, const struct net_bridge_vlan *v,
const struct net_bridge_port *p)
{
if (nla_put_u8(skb, BRIDGE_VLANDB_ENTRY_STATE, br_vlan_get_state(v)) ||
!__vlan_tun_put(skb, v))
......@@ -58,6 +59,12 @@ bool br_vlan_opts_fill(struct sk_buff *skb, const struct net_bridge_vlan *v)
if (nla_put_u8(skb, BRIDGE_VLANDB_ENTRY_MCAST_ROUTER,
br_vlan_multicast_router(v)))
return false;
if (p && !br_multicast_port_ctx_vlan_disabled(&v->port_mcast_ctx) &&
(nla_put_u32(skb, BRIDGE_VLANDB_ENTRY_MCAST_N_GROUPS,
br_multicast_ngroups_get(&v->port_mcast_ctx)) ||
nla_put_u32(skb, BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS,
br_multicast_ngroups_get_max(&v->port_mcast_ctx))))
return false;
#endif
return true;
......@@ -70,6 +77,8 @@ size_t br_vlan_opts_nl_size(void)
+ nla_total_size(sizeof(u32)) /* BRIDGE_VLANDB_TINFO_ID */
#ifdef CONFIG_BRIDGE_IGMP_SNOOPING
+ nla_total_size(sizeof(u8)) /* BRIDGE_VLANDB_ENTRY_MCAST_ROUTER */
+ nla_total_size(sizeof(u32)) /* BRIDGE_VLANDB_ENTRY_MCAST_N_GROUPS */
+ nla_total_size(sizeof(u32)) /* BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS */
#endif
+ 0;
}
......@@ -212,6 +221,22 @@ static int br_vlan_process_one_opts(const struct net_bridge *br,
return err;
*changed = true;
}
if (tb[BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS]) {
u32 val;
if (!p) {
NL_SET_ERR_MSG_MOD(extack, "Can't set mcast_max_groups for non-port vlans");
return -EINVAL;
}
if (br_multicast_port_ctx_vlan_disabled(&v->port_mcast_ctx)) {
NL_SET_ERR_MSG_MOD(extack, "Multicast snooping disabled on this VLAN");
return -EINVAL;
}
val = nla_get_u32(tb[BRIDGE_VLANDB_ENTRY_MCAST_MAX_GROUPS]);
br_multicast_ngroups_set_max(&v->port_mcast_ctx, val);
*changed = true;
}
#endif
return 0;
......
......@@ -41,6 +41,7 @@ EXPORT_TRACEPOINT_SYMBOL_GPL(br_fdb_add);
EXPORT_TRACEPOINT_SYMBOL_GPL(br_fdb_external_learn_add);
EXPORT_TRACEPOINT_SYMBOL_GPL(fdb_delete);
EXPORT_TRACEPOINT_SYMBOL_GPL(br_fdb_update);
EXPORT_TRACEPOINT_SYMBOL_GPL(br_mdb_full);
#endif
#if IS_ENABLED(CONFIG_PAGE_POOL)
......
......@@ -58,7 +58,7 @@
#include "dev.h"
#define RTNL_MAX_TYPE 50
#define RTNL_SLAVE_MAX_TYPE 40
#define RTNL_SLAVE_MAX_TYPE 42
struct rtnl_link {
rtnl_doit_func doit;
......
......@@ -4,6 +4,7 @@ TEST_PROGS = bridge_igmp.sh \
bridge_locked_port.sh \
bridge_mdb.sh \
bridge_mdb_host.sh \
bridge_mdb_max.sh \
bridge_mdb_port_down.sh \
bridge_mld.sh \
bridge_port_isolation.sh \
......
......@@ -1018,26 +1018,6 @@ fwd_test()
ip -6 address del fe80::1/64 dev br0
}
igmpv3_is_in_get()
{
local igmpv3
igmpv3=$(:
)"22:"$( : Type - Membership Report
)"00:"$( : Reserved
)"2a:f8:"$( : Checksum
)"00:00:"$( : Reserved
)"00:01:"$( : Number of Group Records
)"01:"$( : Record Type - IS_IN
)"00:"$( : Aux Data Len
)"00:01:"$( : Number of Sources
)"ef:01:01:01:"$( : Multicast Address - 239.1.1.1
)"c0:00:02:02"$( : Source Address - 192.0.2.2
)
echo $igmpv3
}
ctrl_igmpv3_is_in_test()
{
RET=0
......@@ -1049,7 +1029,7 @@ ctrl_igmpv3_is_in_test()
# IS_IN ( 192.0.2.2 )
$MZ $h1.10 -c 1 -A 192.0.2.1 -B 239.1.1.1 \
-t ip proto=2,p=$(igmpv3_is_in_get) -q
-t ip proto=2,p=$(igmpv3_is_in_get 239.1.1.1 192.0.2.2) -q
bridge -d mdb show dev br0 vid 10 | grep 239.1.1.1 | grep -q 192.0.2.2
check_fail $? "Permanent entry affected by IGMP packet"
......@@ -1062,7 +1042,7 @@ ctrl_igmpv3_is_in_test()
# IS_IN ( 192.0.2.2 )
$MZ $h1.10 -c 1 -A 192.0.2.1 -B 239.1.1.1 \
-t ip proto=2,p=$(igmpv3_is_in_get) -q
-t ip proto=2,p=$(igmpv3_is_in_get 239.1.1.1 192.0.2.2) -q
bridge -d mdb show dev br0 vid 10 | grep 239.1.1.1 | grep -v "src" | \
grep -q 192.0.2.2
......@@ -1074,36 +1054,7 @@ ctrl_igmpv3_is_in_test()
bridge mdb del dev br0 port $swp1 grp 239.1.1.1 vid 10
log_test "IGMPv3 MODE_IS_INCLUE tests"
}
mldv2_is_in_get()
{
local hbh
local icmpv6
hbh=$(:
)"3a:"$( : Next Header - ICMPv6
)"00:"$( : Hdr Ext Len
)"00:00:00:00:00:00:"$( : Options and Padding
)
icmpv6=$(:
)"8f:"$( : Type - MLDv2 Report
)"00:"$( : Code
)"45:39:"$( : Checksum
)"00:00:"$( : Reserved
)"00:01:"$( : Number of Group Records
)"01:"$( : Record Type - IS_IN
)"00:"$( : Aux Data Len
)"00:01:"$( : Number of Sources
)"ff:0e:00:00:00:00:00:00:"$( : Multicast address - ff0e::1
)"00:00:00:00:00:00:00:01:"$( :
)"20:01:0d:b8:00:01:00:00:"$( : Source Address - 2001:db8:1::2
)"00:00:00:00:00:00:00:02:"$( :
)
echo ${hbh}${icmpv6}
log_test "IGMPv3 MODE_IS_INCLUDE tests"
}
ctrl_mldv2_is_in_test()
......@@ -1116,8 +1067,9 @@ ctrl_mldv2_is_in_test()
filter_mode include source_list 2001:db8:1::1
# IS_IN ( 2001:db8:1::2 )
local p=$(mldv2_is_in_get fe80::1 ff0e::1 2001:db8:1::2)
$MZ -6 $h1.10 -c 1 -A fe80::1 -B ff0e::1 \
-t ip hop=1,next=0,p=$(mldv2_is_in_get) -q
-t ip hop=1,next=0,p="$p" -q
bridge -d mdb show dev br0 vid 10 | grep ff0e::1 | \
grep -q 2001:db8:1::2
......@@ -1131,7 +1083,7 @@ ctrl_mldv2_is_in_test()
# IS_IN ( 2001:db8:1::2 )
$MZ -6 $h1.10 -c 1 -A fe80::1 -B ff0e::1 \
-t ip hop=1,next=0,p=$(mldv2_is_in_get) -q
-t ip hop=1,next=0,p="$p" -q
bridge -d mdb show dev br0 vid 10 | grep ff0e::1 | grep -v "src" | \
grep -q 2001:db8:1::2
......
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0
# +-----------------------+ +------------------------+
# | H1 (vrf) | | H2 (vrf) |
# | + $h1.10 | | + $h2.10 |
# | | 192.0.2.1/28 | | | 192.0.2.2/28 |
# | | 2001:db8:1::1/64 | | | 2001:db8:1::2/64 |
# | | | | | |
# | | + $h1.20 | | | + $h2.20 |
# | \ | 198.51.100.1/24 | | \ | 198.51.100.2/24 |
# | \ | 2001:db8:2::1/64 | | \ | 2001:db8:2::2/64 |
# | \| | | \| |
# | + $h1 | | + $h2 |
# +----|------------------+ +----|-------------------+
# | |
# +----|--------------------------------------------------|-------------------+
# | SW | | |
# | +--|--------------------------------------------------|-----------------+ |
# | | + $swp1 BR0 (802.1q) + $swp2 | |
# | | vid 10 vid 10 | |
# | | vid 20 vid 20 | |
# | | | |
# | +-----------------------------------------------------------------------+ |
# +---------------------------------------------------------------------------+
ALL_TESTS="
test_8021d
test_8021q
test_8021qvs
"
NUM_NETIFS=4
source lib.sh
source tc_common.sh
h1_create()
{
simple_if_init $h1
vlan_create $h1 10 v$h1 192.0.2.1/28 2001:db8:1::1/64
vlan_create $h1 20 v$h1 198.51.100.1/24 2001:db8:2::1/64
}
h1_destroy()
{
vlan_destroy $h1 20
vlan_destroy $h1 10
simple_if_fini $h1
}
h2_create()
{
simple_if_init $h2
vlan_create $h2 10 v$h2 192.0.2.2/28
vlan_create $h2 20 v$h2 198.51.100.2/24
}
h2_destroy()
{
vlan_destroy $h2 20
vlan_destroy $h2 10
simple_if_fini $h2
}
switch_create_8021d()
{
log_info "802.1d tests"
ip link add name br0 type bridge vlan_filtering 0 \
mcast_snooping 1 \
mcast_igmp_version 3 mcast_mld_version 2
ip link set dev br0 up
ip link set dev $swp1 master br0
ip link set dev $swp1 up
bridge link set dev $swp1 fastleave on
ip link set dev $swp2 master br0
ip link set dev $swp2 up
}
switch_create_8021q()
{
local br_flags=$1; shift
log_info "802.1q $br_flags${br_flags:+ }tests"
ip link add name br0 type bridge vlan_filtering 1 vlan_default_pvid 0 \
mcast_snooping 1 $br_flags \
mcast_igmp_version 3 mcast_mld_version 2
bridge vlan add vid 10 dev br0 self
bridge vlan add vid 20 dev br0 self
ip link set dev br0 up
ip link set dev $swp1 master br0
ip link set dev $swp1 up
bridge link set dev $swp1 fastleave on
bridge vlan add vid 10 dev $swp1
bridge vlan add vid 20 dev $swp1
ip link set dev $swp2 master br0
ip link set dev $swp2 up
bridge vlan add vid 10 dev $swp2
bridge vlan add vid 20 dev $swp2
}
switch_create_8021qvs()
{
switch_create_8021q "mcast_vlan_snooping 1"
bridge vlan global set dev br0 vid 10 mcast_igmp_version 3
bridge vlan global set dev br0 vid 10 mcast_mld_version 2
bridge vlan global set dev br0 vid 20 mcast_igmp_version 3
bridge vlan global set dev br0 vid 20 mcast_mld_version 2
}
switch_destroy()
{
ip link set dev $swp2 down
ip link set dev $swp2 nomaster
ip link set dev $swp1 down
ip link set dev $swp1 nomaster
ip link set dev br0 down
ip link del dev br0
}
setup_prepare()
{
h1=${NETIFS[p1]}
swp1=${NETIFS[p2]}
swp2=${NETIFS[p3]}
h2=${NETIFS[p4]}
vrf_prepare
forwarding_enable
h1_create
h2_create
}
cleanup()
{
pre_cleanup
switch_destroy 2>/dev/null
h2_destroy
h1_destroy
forwarding_restore
vrf_cleanup
}
cfg_src_list()
{
local IPs=("$@")
local IPstr=$(echo ${IPs[@]} | tr '[:space:]' , | sed 's/,$//')
echo ${IPstr:+source_list }${IPstr}
}
cfg_group_op()
{
local op=$1; shift
local locus=$1; shift
local GRP=$1; shift
local state=$1; shift
local IPs=("$@")
local source_list=$(cfg_src_list ${IPs[@]})
# Everything besides `bridge mdb' uses the "dev X vid Y" syntax,
# so we use it here as well and convert.
local br_locus=$(echo "$locus" | sed 's/^dev /port /')
bridge mdb $op dev br0 $br_locus grp $GRP $state \
filter_mode include $source_list
}
cfg4_entries_op()
{
local op=$1; shift
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local GRP=239.1.1.${grp}
local IPs=$(seq -f 192.0.2.%g 1 $((n - 1)))
cfg_group_op "$op" "$locus" "$GRP" "$state" ${IPs[@]}
}
cfg4_entries_add()
{
cfg4_entries_op add "$@"
}
cfg4_entries_del()
{
cfg4_entries_op del "$@"
}
cfg6_entries_op()
{
local op=$1; shift
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local GRP=ff0e::${grp}
local IPs=$(printf "2001:db8:1::%x\n" $(seq 1 $((n - 1))))
cfg_group_op "$op" "$locus" "$GRP" "$state" ${IPs[@]}
}
cfg6_entries_add()
{
cfg6_entries_op add "$@"
}
cfg6_entries_del()
{
cfg6_entries_op del "$@"
}
locus_dev_peer()
{
local dev_kw=$1; shift
local dev=$1; shift
local vid_kw=$1; shift
local vid=$1; shift
echo "$h1.${vid:-10}"
}
locus_dev()
{
local dev_kw=$1; shift
local dev=$1; shift
echo $dev
}
ctl4_entries_add()
{
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local IPs=$(seq -f 192.0.2.%g 1 $((n - 1)))
local peer=$(locus_dev_peer $locus)
local GRP=239.1.1.${grp}
$MZ $peer -c 1 -A 192.0.2.1 -B $GRP \
-t ip proto=2,p=$(igmpv3_is_in_get $GRP $IPs) -q
sleep 1
local nn=$(bridge mdb show dev br0 | grep $GRP | wc -l)
if ((nn != n)); then
echo mcast_max_groups > /dev/stderr
false
fi
}
ctl4_entries_del()
{
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local peer=$(locus_dev_peer $locus)
local GRP=239.1.1.${grp}
$MZ $peer -c 1 -A 192.0.2.1 -B 224.0.0.2 \
-t ip proto=2,p=$(igmpv2_leave_get $GRP) -q
sleep 1
! bridge mdb show dev br0 | grep -q $GRP
}
ctl6_entries_add()
{
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local IPs=$(printf "2001:db8:1::%x\n" $(seq 1 $((n - 1))))
local peer=$(locus_dev_peer $locus)
local SIP=fe80::1
local GRP=ff0e::${grp}
local p=$(mldv2_is_in_get $SIP $GRP $IPs)
$MZ -6 $peer -c 1 -A $SIP -B $GRP -t ip hop=1,next=0,p="$p" -q
sleep 1
local nn=$(bridge mdb show dev br0 | grep $GRP | wc -l)
if ((nn != n)); then
echo mcast_max_groups > /dev/stderr
false
fi
}
ctl6_entries_del()
{
local locus=$1; shift
local state=$1; shift
local n=$1; shift
local grp=${1:-1}; shift
local peer=$(locus_dev_peer $locus)
local SIP=fe80::1
local GRP=ff0e::${grp}
local p=$(mldv1_done_get $SIP $GRP)
$MZ -6 $peer -c 1 -A $SIP -B $GRP -t ip hop=1,next=0,p="$p" -q
sleep 1
! bridge mdb show dev br0 | grep -q $GRP
}
bridge_maxgroups_errmsg_check_cfg()
{
local msg=$1; shift
local needle=$1; shift
echo "$msg" | grep -q mcast_max_groups
check_err $? "Adding MDB entries failed for the wrong reason: $msg"
}
bridge_maxgroups_errmsg_check_cfg4()
{
bridge_maxgroups_errmsg_check_cfg "$@"
}
bridge_maxgroups_errmsg_check_cfg6()
{
bridge_maxgroups_errmsg_check_cfg "$@"
}
bridge_maxgroups_errmsg_check_ctl4()
{
:
}
bridge_maxgroups_errmsg_check_ctl6()
{
:
}
bridge_port_ngroups_get()
{
local locus=$1; shift
bridge -j -d link show $locus |
jq '.[].mcast_n_groups'
}
bridge_port_maxgroups_get()
{
local locus=$1; shift
bridge -j -d link show $locus |
jq '.[].mcast_max_groups'
}
bridge_port_maxgroups_set()
{
local locus=$1; shift
local max=$1; shift
bridge link set dev $(locus_dev $locus) mcast_max_groups $max
}
bridge_port_vlan_ngroups_get()
{
local locus=$1; shift
bridge -j -d vlan show $locus |
jq '.[].vlans[].mcast_n_groups'
}
bridge_port_vlan_maxgroups_get()
{
local locus=$1; shift
bridge -j -d vlan show $locus |
jq '.[].vlans[].mcast_max_groups'
}
bridge_port_vlan_maxgroups_set()
{
local locus=$1; shift
local max=$1; shift
bridge vlan set $locus mcast_max_groups $max
}
test_ngroups_reporting()
{
local CFG=$1; shift
local context=$1; shift
local locus=$1; shift
RET=0
local n0=$(bridge_${context}_ngroups_get "$locus")
${CFG}_entries_add "$locus" temp 5
check_err $? "Couldn't add MDB entries"
local n1=$(bridge_${context}_ngroups_get "$locus")
((n1 == n0 + 5))
check_err $? "Number of groups was $n0, now is $n1, but $((n0 + 5)) expected"
${CFG}_entries_del "$locus" temp 5
check_err $? "Couldn't delete MDB entries"
local n2=$(bridge_${context}_ngroups_get "$locus")
((n2 == n0))
check_err $? "Number of groups was $n0, now is $n2, but should be back to $n0"
log_test "$CFG: $context: ngroups reporting"
}
test_8021d_ngroups_reporting_cfg4()
{
test_ngroups_reporting cfg4 port "dev $swp1"
}
test_8021d_ngroups_reporting_ctl4()
{
test_ngroups_reporting ctl4 port "dev $swp1"
}
test_8021d_ngroups_reporting_cfg6()
{
test_ngroups_reporting cfg6 port "dev $swp1"
}
test_8021d_ngroups_reporting_ctl6()
{
test_ngroups_reporting ctl6 port "dev $swp1"
}
test_8021q_ngroups_reporting_cfg4()
{
test_ngroups_reporting cfg4 port "dev $swp1 vid 10"
}
test_8021q_ngroups_reporting_ctl4()
{
test_ngroups_reporting ctl4 port "dev $swp1 vid 10"
}
test_8021q_ngroups_reporting_cfg6()
{
test_ngroups_reporting cfg6 port "dev $swp1 vid 10"
}
test_8021q_ngroups_reporting_ctl6()
{
test_ngroups_reporting ctl6 port "dev $swp1 vid 10"
}
test_8021qvs_ngroups_reporting_cfg4()
{
test_ngroups_reporting cfg4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_ngroups_reporting_ctl4()
{
test_ngroups_reporting ctl4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_ngroups_reporting_cfg6()
{
test_ngroups_reporting cfg6 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_ngroups_reporting_ctl6()
{
test_ngroups_reporting ctl6 port_vlan "dev $swp1 vid 10"
}
test_ngroups_cross_vlan()
{
local CFG=$1; shift
local locus1="dev $swp1 vid 10"
local locus2="dev $swp1 vid 20"
RET=0
local n10=$(bridge_port_vlan_ngroups_get "$locus1")
local n20=$(bridge_port_vlan_ngroups_get "$locus2")
${CFG}_entries_add "$locus1" temp 5 111
check_err $? "Couldn't add MDB entries to VLAN 10"
local n11=$(bridge_port_vlan_ngroups_get "$locus1")
local n21=$(bridge_port_vlan_ngroups_get "$locus2")
((n11 == n10 + 5))
check_err $? "Number of groups at VLAN 10 was $n10, now is $n11, but 5 entries added on VLAN 10, $((n10 + 5)) expected"
((n21 == n20))
check_err $? "Number of groups at VLAN 20 was $n20, now is $n21, but no change expected on VLAN 20"
${CFG}_entries_add "$locus2" temp 5 112
check_err $? "Couldn't add MDB entries to VLAN 20"
local n12=$(bridge_port_vlan_ngroups_get "$locus1")
local n22=$(bridge_port_vlan_ngroups_get "$locus2")
((n12 == n11))
check_err $? "Number of groups at VLAN 10 was $n11, now is $n12, but no change expected on VLAN 10"
((n22 == n21 + 5))
check_err $? "Number of groups at VLAN 20 was $n21, now is $n22, but 5 entries added on VLAN 20, $((n21 + 5)) expected"
${CFG}_entries_del "$locus1" temp 5 111
check_err $? "Couldn't delete MDB entries from VLAN 10"
${CFG}_entries_del "$locus2" temp 5 112
check_err $? "Couldn't delete MDB entries from VLAN 20"
local n13=$(bridge_port_vlan_ngroups_get "$locus1")
local n23=$(bridge_port_vlan_ngroups_get "$locus2")
((n13 == n10))
check_err $? "Number of groups at VLAN 10 was $n10, now is $n13, but should be back to $n10"
((n23 == n20))
check_err $? "Number of groups at VLAN 20 was $n20, now is $n23, but should be back to $n20"
log_test "$CFG: port_vlan: isolation of port and per-VLAN ngroups"
}
test_8021qvs_ngroups_cross_vlan_cfg4()
{
test_ngroups_cross_vlan cfg4
}
test_8021qvs_ngroups_cross_vlan_ctl4()
{
test_ngroups_cross_vlan ctl4
}
test_8021qvs_ngroups_cross_vlan_cfg6()
{
test_ngroups_cross_vlan cfg6
}
test_8021qvs_ngroups_cross_vlan_ctl6()
{
test_ngroups_cross_vlan ctl6
}
test_maxgroups_zero()
{
local CFG=$1; shift
local context=$1; shift
local locus=$1; shift
RET=0
local max
max=$(bridge_${context}_maxgroups_get "$locus")
((max == 0))
check_err $? "Max groups on $locus should be 0, but $max reported"
bridge_${context}_maxgroups_set "$locus" 100
check_err $? "Failed to set max to 100"
max=$(bridge_${context}_maxgroups_get "$locus")
((max == 100))
check_err $? "Max groups expected to be 100, but $max reported"
bridge_${context}_maxgroups_set "$locus" 0
check_err $? "Couldn't set maximum to 0"
# Test that setting 0 explicitly still serves as infinity.
${CFG}_entries_add "$locus" temp 5
check_err $? "Adding 5 MDB entries failed but should have passed"
${CFG}_entries_del "$locus" temp 5
check_err $? "Couldn't delete MDB entries"
log_test "$CFG: $context maxgroups: reporting and treatment of 0"
}
test_8021d_maxgroups_zero_cfg4()
{
test_maxgroups_zero cfg4 port "dev $swp1"
}
test_8021d_maxgroups_zero_ctl4()
{
test_maxgroups_zero ctl4 port "dev $swp1"
}
test_8021d_maxgroups_zero_cfg6()
{
test_maxgroups_zero cfg6 port "dev $swp1"
}
test_8021d_maxgroups_zero_ctl6()
{
test_maxgroups_zero ctl6 port "dev $swp1"
}
test_8021q_maxgroups_zero_cfg4()
{
test_maxgroups_zero cfg4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_zero_ctl4()
{
test_maxgroups_zero ctl4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_zero_cfg6()
{
test_maxgroups_zero cfg6 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_zero_ctl6()
{
test_maxgroups_zero ctl6 port "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_zero_cfg4()
{
test_maxgroups_zero cfg4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_zero_ctl4()
{
test_maxgroups_zero ctl4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_zero_cfg6()
{
test_maxgroups_zero cfg6 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_zero_ctl6()
{
test_maxgroups_zero ctl6 port_vlan "dev $swp1 vid 10"
}
test_maxgroups_zero_cross_vlan()
{
local CFG=$1; shift
local locus0="dev $swp1"
local locus1="dev $swp1 vid 10"
local locus2="dev $swp1 vid 20"
local max
RET=0
bridge_port_vlan_maxgroups_set "$locus1" 100
check_err $? "$locus1: Failed to set max to 100"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 0))
check_err $? "$locus0: Max groups expected to be 0, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 0))
check_err $? "$locus2: Max groups expected to be 0, but $max reported"
bridge_port_vlan_maxgroups_set "$locus2" 100
check_err $? "$locus2: Failed to set max to 100"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 0))
check_err $? "$locus0: Max groups expected to be 0, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 100))
check_err $? "$locus2: Max groups expected to be 100, but $max reported"
bridge_port_maxgroups_set "$locus0" 100
check_err $? "$locus0: Failed to set max to 100"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 100))
check_err $? "$locus0: Max groups expected to be 100, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 100))
check_err $? "$locus2: Max groups expected to be 100, but $max reported"
bridge_port_vlan_maxgroups_set "$locus1" 0
check_err $? "$locus1: Failed to set max to 0"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 100))
check_err $? "$locus0: Max groups expected to be 100, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 100))
check_err $? "$locus2: Max groups expected to be 100, but $max reported"
bridge_port_vlan_maxgroups_set "$locus2" 0
check_err $? "$locus2: Failed to set max to 0"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 100))
check_err $? "$locus0: Max groups expected to be 100, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 0))
check_err $? "$locus2: Max groups expected to be 0 but $max reported"
bridge_port_maxgroups_set "$locus0" 0
check_err $? "$locus0: Failed to set max to 0"
max=$(bridge_port_maxgroups_get "$locus0")
((max == 0))
check_err $? "$locus0: Max groups expected to be 0, but $max reported"
max=$(bridge_port_vlan_maxgroups_get "$locus2")
((max == 0))
check_err $? "$locus2: Max groups expected to be 0, but $max reported"
log_test "$CFG: port_vlan maxgroups: isolation of port and per-VLAN maximums"
}
test_8021qvs_maxgroups_zero_cross_vlan_cfg4()
{
test_maxgroups_zero_cross_vlan cfg4
}
test_8021qvs_maxgroups_zero_cross_vlan_ctl4()
{
test_maxgroups_zero_cross_vlan ctl4
}
test_8021qvs_maxgroups_zero_cross_vlan_cfg6()
{
test_maxgroups_zero_cross_vlan cfg6
}
test_8021qvs_maxgroups_zero_cross_vlan_ctl6()
{
test_maxgroups_zero_cross_vlan ctl6
}
test_maxgroups_too_low()
{
local CFG=$1; shift
local context=$1; shift
local locus=$1; shift
RET=0
local n=$(bridge_${context}_ngroups_get "$locus")
local msg
${CFG}_entries_add "$locus" temp 5 111
check_err $? "$locus: Couldn't add MDB entries"
bridge_${context}_maxgroups_set "$locus" $((n+2))
check_err $? "$locus: Setting maxgroups to $((n+2)) failed"
msg=$(${CFG}_entries_add "$locus" temp 2 112 2>&1)
check_fail $? "$locus: Adding more entries passed when max<n"
bridge_maxgroups_errmsg_check_cfg "$msg"
${CFG}_entries_del "$locus" temp 5 111
check_err $? "$locus: Couldn't delete MDB entries"
${CFG}_entries_add "$locus" temp 2 112
check_err $? "$locus: Adding more entries failed"
${CFG}_entries_del "$locus" temp 2 112
check_err $? "$locus: Deleting more entries failed"
bridge_${context}_maxgroups_set "$locus" 0
check_err $? "$locus: Couldn't set maximum to 0"
log_test "$CFG: $context maxgroups: configure below ngroups"
}
test_8021d_maxgroups_too_low_cfg4()
{
test_maxgroups_too_low cfg4 port "dev $swp1"
}
test_8021d_maxgroups_too_low_ctl4()
{
test_maxgroups_too_low ctl4 port "dev $swp1"
}
test_8021d_maxgroups_too_low_cfg6()
{
test_maxgroups_too_low cfg6 port "dev $swp1"
}
test_8021d_maxgroups_too_low_ctl6()
{
test_maxgroups_too_low ctl6 port "dev $swp1"
}
test_8021q_maxgroups_too_low_cfg4()
{
test_maxgroups_too_low cfg4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_low_ctl4()
{
test_maxgroups_too_low ctl4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_low_cfg6()
{
test_maxgroups_too_low cfg6 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_low_ctl6()
{
test_maxgroups_too_low ctl6 port "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_low_cfg4()
{
test_maxgroups_too_low cfg4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_low_ctl4()
{
test_maxgroups_too_low ctl4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_low_cfg6()
{
test_maxgroups_too_low cfg6 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_low_ctl6()
{
test_maxgroups_too_low ctl6 port_vlan "dev $swp1 vid 10"
}
test_maxgroups_too_many_entries()
{
local CFG=$1; shift
local context=$1; shift
local locus=$1; shift
RET=0
local n=$(bridge_${context}_ngroups_get "$locus")
local msg
# Configure a low maximum
bridge_${context}_maxgroups_set "$locus" $((n+1))
check_err $? "$locus: Couldn't set maximum"
# Try to add more entries than the configured maximum
msg=$(${CFG}_entries_add "$locus" temp 5 2>&1)
check_fail $? "Adding 5 MDB entries passed, but should have failed"
bridge_maxgroups_errmsg_check_${CFG} "$msg"
# When adding entries through the control path, as many as possible
# get created. That's consistent with the mcast_hash_max behavior.
# So there, drop the entries explicitly.
if [[ ${CFG%[46]} == ctl ]]; then
${CFG}_entries_del "$locus" temp 17 2>&1
fi
local n2=$(bridge_${context}_ngroups_get "$locus")
((n2 == n))
check_err $? "Number of groups was $n, but after a failed attempt to add MDB entries it changed to $n2"
bridge_${context}_maxgroups_set "$locus" 0
check_err $? "$locus: Couldn't set maximum to 0"
log_test "$CFG: $context maxgroups: add too many MDB entries"
}
test_8021d_maxgroups_too_many_entries_cfg4()
{
test_maxgroups_too_many_entries cfg4 port "dev $swp1"
}
test_8021d_maxgroups_too_many_entries_ctl4()
{
test_maxgroups_too_many_entries ctl4 port "dev $swp1"
}
test_8021d_maxgroups_too_many_entries_cfg6()
{
test_maxgroups_too_many_entries cfg6 port "dev $swp1"
}
test_8021d_maxgroups_too_many_entries_ctl6()
{
test_maxgroups_too_many_entries ctl6 port "dev $swp1"
}
test_8021q_maxgroups_too_many_entries_cfg4()
{
test_maxgroups_too_many_entries cfg4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_many_entries_ctl4()
{
test_maxgroups_too_many_entries ctl4 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_many_entries_cfg6()
{
test_maxgroups_too_many_entries cfg6 port "dev $swp1 vid 10"
}
test_8021q_maxgroups_too_many_entries_ctl6()
{
test_maxgroups_too_many_entries ctl6 port "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_many_entries_cfg4()
{
test_maxgroups_too_many_entries cfg4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_many_entries_ctl4()
{
test_maxgroups_too_many_entries ctl4 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_many_entries_cfg6()
{
test_maxgroups_too_many_entries cfg6 port_vlan "dev $swp1 vid 10"
}
test_8021qvs_maxgroups_too_many_entries_ctl6()
{
test_maxgroups_too_many_entries ctl6 port_vlan "dev $swp1 vid 10"
}
test_maxgroups_too_many_cross_vlan()
{
local CFG=$1; shift
RET=0
local locus0="dev $swp1"
local locus1="dev $swp1 vid 10"
local locus2="dev $swp1 vid 20"
local n1=$(bridge_port_vlan_ngroups_get "$locus1")
local n2=$(bridge_port_vlan_ngroups_get "$locus2")
local msg
if ((n1 > n2)); then
local tmp=$n1
n1=$n2
n2=$tmp
tmp="$locus1"
locus1="$locus2"
locus2="$tmp"
fi
# Now 0 <= n1 <= n2.
${CFG}_entries_add "$locus2" temp 5 112
check_err $? "Couldn't add 5 entries"
n2=$(bridge_port_vlan_ngroups_get "$locus2")
# Now 0 <= n1 < n2-1.
# Setting locus1'maxgroups to n2-1 should pass. The number is
# smaller than both the absolute number of MDB entries, and in
# particular than number of locus2's number of entries, but it is
# large enough to cover locus1's entries. Thus we check that
# individual VLAN's ngroups are independent.
bridge_port_vlan_maxgroups_set "$locus1" $((n2-1))
check_err $? "Setting ${locus1}'s maxgroups to $((n2-1)) failed"
msg=$(${CFG}_entries_add "$locus1" temp $n2 111 2>&1)
check_fail $? "$locus1: Adding $n2 MDB entries passed, but should have failed"
bridge_maxgroups_errmsg_check_${CFG} "$msg"
bridge_port_maxgroups_set "$locus0" $((n1 + n2 + 2))
check_err $? "$locus0: Couldn't set maximum"
msg=$(${CFG}_entries_add "$locus1" temp 5 111 2>&1)
check_fail $? "$locus1: Adding 5 MDB entries passed, but should have failed"
bridge_maxgroups_errmsg_check_${CFG} "$msg"
# IGMP/MLD packets can cause several entries to be added, before
# the maximum is hit and the rest is then bounced. Remove what was
# committed, if anything.
${CFG}_entries_del "$locus1" temp 5 111 2>/dev/null
${CFG}_entries_add "$locus1" temp 2 111
check_err $? "$locus1: Adding 2 MDB entries failed, but should have passed"
${CFG}_entries_del "$locus1" temp 2 111
check_err $? "Couldn't delete MDB entries"
${CFG}_entries_del "$locus2" temp 5 112
check_err $? "Couldn't delete MDB entries"
bridge_port_vlan_maxgroups_set "$locus1" 0
check_err $? "$locus1: Couldn't set maximum to 0"
bridge_port_maxgroups_set "$locus0" 0
check_err $? "$locus0: Couldn't set maximum to 0"
log_test "$CFG: port_vlan maxgroups: isolation of port and per-VLAN ngroups"
}
test_8021qvs_maxgroups_too_many_cross_vlan_cfg4()
{
test_maxgroups_too_many_cross_vlan cfg4
}
test_8021qvs_maxgroups_too_many_cross_vlan_ctl4()
{
test_maxgroups_too_many_cross_vlan ctl4
}
test_8021qvs_maxgroups_too_many_cross_vlan_cfg6()
{
test_maxgroups_too_many_cross_vlan cfg6
}
test_8021qvs_maxgroups_too_many_cross_vlan_ctl6()
{
test_maxgroups_too_many_cross_vlan ctl6
}
test_vlan_attributes()
{
local locus=$1; shift
local expect=$1; shift
RET=0
local max=$(bridge_port_vlan_maxgroups_get "$locus")
local n=$(bridge_port_vlan_ngroups_get "$locus")
eval "[[ $max $expect ]]"
check_err $? "$locus: maxgroups attribute expected to be $expect, but was $max"
eval "[[ $n $expect ]]"
check_err $? "$locus: ngroups attribute expected to be $expect, but was $n"
log_test "port_vlan: presence of ngroups and maxgroups attributes"
}
test_8021q_vlan_attributes()
{
test_vlan_attributes "dev $swp1 vid 10" "== null"
}
test_8021qvs_vlan_attributes()
{
test_vlan_attributes "dev $swp1 vid 10" "-ge 0"
}
test_toggle_vlan_snooping()
{
local mode=$1; shift
RET=0
local CFG=cfg4
local context=port_vlan
local locus="dev $swp1 vid 10"
${CFG}_entries_add "$locus" $mode 5
check_err $? "Couldn't add MDB entries"
bridge_${context}_maxgroups_set "$locus" 100
check_err $? "Failed to set max to 100"
ip link set dev br0 type bridge mcast_vlan_snooping 0
sleep 1
ip link set dev br0 type bridge mcast_vlan_snooping 1
local n=$(bridge_${context}_ngroups_get "$locus")
local nn=$(bridge mdb show dev br0 | grep $swp1 | wc -l)
((nn == n))
check_err $? "mcast_n_groups expected to be $nn, but $n reported"
local max=$(bridge_${context}_maxgroups_get "$locus")
((max == 100))
check_err $? "Max groups expected to be 100 but $max reported"
bridge_${context}_maxgroups_set "$locus" 0
check_err $? "Failed to set max to 0"
log_test "$CFG: $context: $mode: mcast_vlan_snooping toggle"
}
test_toggle_vlan_snooping_temp()
{
test_toggle_vlan_snooping temp
}
test_toggle_vlan_snooping_permanent()
{
test_toggle_vlan_snooping permanent
}
# ngroup test suites
test_8021d_ngroups_cfg4()
{
test_8021d_ngroups_reporting_cfg4
}
test_8021d_ngroups_ctl4()
{
test_8021d_ngroups_reporting_ctl4
}
test_8021d_ngroups_cfg6()
{
test_8021d_ngroups_reporting_cfg6
}
test_8021d_ngroups_ctl6()
{
test_8021d_ngroups_reporting_ctl6
}
test_8021q_ngroups_cfg4()
{
test_8021q_ngroups_reporting_cfg4
}
test_8021q_ngroups_ctl4()
{
test_8021q_ngroups_reporting_ctl4
}
test_8021q_ngroups_cfg6()
{
test_8021q_ngroups_reporting_cfg6
}
test_8021q_ngroups_ctl6()
{
test_8021q_ngroups_reporting_ctl6
}
test_8021qvs_ngroups_cfg4()
{
test_8021qvs_ngroups_reporting_cfg4
test_8021qvs_ngroups_cross_vlan_cfg4
}
test_8021qvs_ngroups_ctl4()
{
test_8021qvs_ngroups_reporting_ctl4
test_8021qvs_ngroups_cross_vlan_ctl4
}
test_8021qvs_ngroups_cfg6()
{
test_8021qvs_ngroups_reporting_cfg6
test_8021qvs_ngroups_cross_vlan_cfg6
}
test_8021qvs_ngroups_ctl6()
{
test_8021qvs_ngroups_reporting_ctl6
test_8021qvs_ngroups_cross_vlan_ctl6
}
# maxgroups test suites
test_8021d_maxgroups_cfg4()
{
test_8021d_maxgroups_zero_cfg4
test_8021d_maxgroups_too_low_cfg4
test_8021d_maxgroups_too_many_entries_cfg4
}
test_8021d_maxgroups_ctl4()
{
test_8021d_maxgroups_zero_ctl4
test_8021d_maxgroups_too_low_ctl4
test_8021d_maxgroups_too_many_entries_ctl4
}
test_8021d_maxgroups_cfg6()
{
test_8021d_maxgroups_zero_cfg6
test_8021d_maxgroups_too_low_cfg6
test_8021d_maxgroups_too_many_entries_cfg6
}
test_8021d_maxgroups_ctl6()
{
test_8021d_maxgroups_zero_ctl6
test_8021d_maxgroups_too_low_ctl6
test_8021d_maxgroups_too_many_entries_ctl6
}
test_8021q_maxgroups_cfg4()
{
test_8021q_maxgroups_zero_cfg4
test_8021q_maxgroups_too_low_cfg4
test_8021q_maxgroups_too_many_entries_cfg4
}
test_8021q_maxgroups_ctl4()
{
test_8021q_maxgroups_zero_ctl4
test_8021q_maxgroups_too_low_ctl4
test_8021q_maxgroups_too_many_entries_ctl4
}
test_8021q_maxgroups_cfg6()
{
test_8021q_maxgroups_zero_cfg6
test_8021q_maxgroups_too_low_cfg6
test_8021q_maxgroups_too_many_entries_cfg6
}
test_8021q_maxgroups_ctl6()
{
test_8021q_maxgroups_zero_ctl6
test_8021q_maxgroups_too_low_ctl6
test_8021q_maxgroups_too_many_entries_ctl6
}
test_8021qvs_maxgroups_cfg4()
{
test_8021qvs_maxgroups_zero_cfg4
test_8021qvs_maxgroups_zero_cross_vlan_cfg4
test_8021qvs_maxgroups_too_low_cfg4
test_8021qvs_maxgroups_too_many_entries_cfg4
test_8021qvs_maxgroups_too_many_cross_vlan_cfg4
}
test_8021qvs_maxgroups_ctl4()
{
test_8021qvs_maxgroups_zero_ctl4
test_8021qvs_maxgroups_zero_cross_vlan_ctl4
test_8021qvs_maxgroups_too_low_ctl4
test_8021qvs_maxgroups_too_many_entries_ctl4
test_8021qvs_maxgroups_too_many_cross_vlan_ctl4
}
test_8021qvs_maxgroups_cfg6()
{
test_8021qvs_maxgroups_zero_cfg6
test_8021qvs_maxgroups_zero_cross_vlan_cfg6
test_8021qvs_maxgroups_too_low_cfg6
test_8021qvs_maxgroups_too_many_entries_cfg6
test_8021qvs_maxgroups_too_many_cross_vlan_cfg6
}
test_8021qvs_maxgroups_ctl6()
{
test_8021qvs_maxgroups_zero_ctl6
test_8021qvs_maxgroups_zero_cross_vlan_ctl6
test_8021qvs_maxgroups_too_low_ctl6
test_8021qvs_maxgroups_too_many_entries_ctl6
test_8021qvs_maxgroups_too_many_cross_vlan_ctl6
}
# other test suites
test_8021qvs_toggle_vlan_snooping()
{
test_toggle_vlan_snooping_temp
test_toggle_vlan_snooping_permanent
}
# test groups
test_8021d()
{
# Tests for vlan_filtering 0 mcast_vlan_snooping 0.
switch_create_8021d
setup_wait
test_8021d_ngroups_cfg4
test_8021d_ngroups_ctl4
test_8021d_ngroups_cfg6
test_8021d_ngroups_ctl6
test_8021d_maxgroups_cfg4
test_8021d_maxgroups_ctl4
test_8021d_maxgroups_cfg6
test_8021d_maxgroups_ctl6
switch_destroy
}
test_8021q()
{
# Tests for vlan_filtering 1 mcast_vlan_snooping 0.
switch_create_8021q
setup_wait
test_8021q_vlan_attributes
test_8021q_ngroups_cfg4
test_8021q_ngroups_ctl4
test_8021q_ngroups_cfg6
test_8021q_ngroups_ctl6
test_8021q_maxgroups_cfg4
test_8021q_maxgroups_ctl4
test_8021q_maxgroups_cfg6
test_8021q_maxgroups_ctl6
switch_destroy
}
test_8021qvs()
{
# Tests for vlan_filtering 1 mcast_vlan_snooping 1.
switch_create_8021qvs
setup_wait
test_8021qvs_vlan_attributes
test_8021qvs_ngroups_cfg4
test_8021qvs_ngroups_ctl4
test_8021qvs_ngroups_cfg6
test_8021qvs_ngroups_ctl6
test_8021qvs_maxgroups_cfg4
test_8021qvs_maxgroups_ctl4
test_8021qvs_maxgroups_cfg6
test_8021qvs_maxgroups_ctl6
test_8021qvs_toggle_vlan_snooping
switch_destroy
}
trap cleanup EXIT
setup_prepare
tests_run
exit $EXIT_STATUS
......@@ -1671,3 +1671,219 @@ hw_stats_monitor_test()
log_test "${type}_stats notifications"
}
ipv4_to_bytes()
{
local IP=$1; shift
printf '%02x:' ${IP//./ } |
sed 's/:$//'
}
# Convert a given IPv6 address, `IP' such that the :: token, if present, is
# expanded, and each 16-bit group is padded with zeroes to be 4 hexadecimal
# digits. An optional `BYTESEP' parameter can be given to further separate
# individual bytes of each 16-bit group.
expand_ipv6()
{
local IP=$1; shift
local bytesep=$1; shift
local cvt_ip=${IP/::/_}
local colons=${cvt_ip//[^:]/}
local allcol=:::::::
# IP where :: -> the appropriate number of colons:
local allcol_ip=${cvt_ip/_/${allcol:${#colons}}}
echo $allcol_ip | tr : '\n' |
sed s/^/0000/ |
sed 's/.*\(..\)\(..\)/\1'"$bytesep"'\2/' |
tr '\n' : |
sed 's/:$//'
}
ipv6_to_bytes()
{
local IP=$1; shift
expand_ipv6 "$IP" :
}
u16_to_bytes()
{
local u16=$1; shift
printf "%04x" $u16 | sed 's/^/000/;s/^.*\(..\)\(..\)$/\1:\2/'
}
# Given a mausezahn-formatted payload (colon-separated bytes given as %02x),
# possibly with a keyword CHECKSUM stashed where a 16-bit checksum should be,
# calculate checksum as per RFC 1071, assuming the CHECKSUM field (if any)
# stands for 00:00.
payload_template_calc_checksum()
{
local payload=$1; shift
(
# Set input radix.
echo "16i"
# Push zero for the initial checksum.
echo 0
# Pad the payload with a terminating 00: in case we get an odd
# number of bytes.
echo "${payload%:}:00:" |
sed 's/CHECKSUM/00:00/g' |
tr '[:lower:]' '[:upper:]' |
# Add the word to the checksum.
sed 's/\(..\):\(..\):/\1\2+\n/g' |
# Strip the extra odd byte we pushed if left unconverted.
sed 's/\(..\):$//'
echo "10000 ~ +" # Calculate and add carry.
echo "FFFF r - p" # Bit-flip and print.
) |
dc |
tr '[:upper:]' '[:lower:]'
}
payload_template_expand_checksum()
{
local payload=$1; shift
local checksum=$1; shift
local ckbytes=$(u16_to_bytes $checksum)
echo "$payload" | sed "s/CHECKSUM/$ckbytes/g"
}
payload_template_nbytes()
{
local payload=$1; shift
payload_template_expand_checksum "${payload%:}" 0 |
sed 's/:/\n/g' | wc -l
}
igmpv3_is_in_get()
{
local GRP=$1; shift
local sources=("$@")
local igmpv3
local nsources=$(u16_to_bytes ${#sources[@]})
# IS_IN ( $sources )
igmpv3=$(:
)"22:"$( : Type - Membership Report
)"00:"$( : Reserved
)"CHECKSUM:"$( : Checksum
)"00:00:"$( : Reserved
)"00:01:"$( : Number of Group Records
)"01:"$( : Record Type - IS_IN
)"00:"$( : Aux Data Len
)"${nsources}:"$( : Number of Sources
)"$(ipv4_to_bytes $GRP):"$( : Multicast Address
)"$(for src in "${sources[@]}"; do
ipv4_to_bytes $src
echo -n :
done)"$( : Source Addresses
)
local checksum=$(payload_template_calc_checksum "$igmpv3")
payload_template_expand_checksum "$igmpv3" $checksum
}
igmpv2_leave_get()
{
local GRP=$1; shift
local payload=$(:
)"17:"$( : Type - Leave Group
)"00:"$( : Max Resp Time - not meaningful
)"CHECKSUM:"$( : Checksum
)"$(ipv4_to_bytes $GRP)"$( : Group Address
)
local checksum=$(payload_template_calc_checksum "$payload")
payload_template_expand_checksum "$payload" $checksum
}
mldv2_is_in_get()
{
local SIP=$1; shift
local GRP=$1; shift
local sources=("$@")
local hbh
local icmpv6
local nsources=$(u16_to_bytes ${#sources[@]})
hbh=$(:
)"3a:"$( : Next Header - ICMPv6
)"00:"$( : Hdr Ext Len
)"00:00:00:00:00:00:"$( : Options and Padding
)
icmpv6=$(:
)"8f:"$( : Type - MLDv2 Report
)"00:"$( : Code
)"CHECKSUM:"$( : Checksum
)"00:00:"$( : Reserved
)"00:01:"$( : Number of Group Records
)"01:"$( : Record Type - IS_IN
)"00:"$( : Aux Data Len
)"${nsources}:"$( : Number of Sources
)"$(ipv6_to_bytes $GRP):"$( : Multicast address
)"$(for src in "${sources[@]}"; do
ipv6_to_bytes $src
echo -n :
done)"$( : Source Addresses
)
local len=$(u16_to_bytes $(payload_template_nbytes $icmpv6))
local sudohdr=$(:
)"$(ipv6_to_bytes $SIP):"$( : SIP
)"$(ipv6_to_bytes $GRP):"$( : DIP is multicast address
)"${len}:"$( : Upper-layer length
)"00:3a:"$( : Zero and next-header
)
local checksum=$(payload_template_calc_checksum ${sudohdr}${icmpv6})
payload_template_expand_checksum "$hbh$icmpv6" $checksum
}
mldv1_done_get()
{
local SIP=$1; shift
local GRP=$1; shift
local hbh
local icmpv6
hbh=$(:
)"3a:"$( : Next Header - ICMPv6
)"00:"$( : Hdr Ext Len
)"00:00:00:00:00:00:"$( : Options and Padding
)
icmpv6=$(:
)"84:"$( : Type - MLDv1 Done
)"00:"$( : Code
)"CHECKSUM:"$( : Checksum
)"00:00:"$( : Max Resp Delay - not meaningful
)"00:00:"$( : Reserved
)"$(ipv6_to_bytes $GRP):"$( : Multicast address
)
local len=$(u16_to_bytes $(payload_template_nbytes $icmpv6))
local sudohdr=$(:
)"$(ipv6_to_bytes $SIP):"$( : SIP
)"$(ipv6_to_bytes $GRP):"$( : DIP is multicast address
)"${len}:"$( : Upper-layer length
)"00:3a:"$( : Zero and next-header
)
local checksum=$(payload_template_calc_checksum ${sudohdr}${icmpv6})
payload_template_expand_checksum "$hbh$icmpv6" $checksum
}
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment